'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _ajv = require('ajv');

var _ajv2 = _interopRequireDefault(_ajv);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

function errorToProperty(err) {
  var _err$params = err.params,
      params = _err$params === undefined ? {} : _err$params;


  if (params.missingProperty) {
    return params.missingProperty;
  }

  return undefined;
}

var Validator = (_temp = _class = function (_Component) {
  _inherits(Validator, _Component);

  function Validator(props, context) {
    var _this2 = this;

    _classCallCheck(this, Validator);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props, context));

    _this.validate = function () {
      var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(value) {
        var validator, valid, errors;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                validator = _this.state.validator;

                if (validator) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt('return', []);

              case 3:
                valid = validator(value);

                if (!valid) {
                  _context.next = 6;
                  break;
                }

                return _context.abrupt('return', []);

              case 6:
                errors = validator.errors;
                return _context.abrupt('return', errors.map(function (err) {
                  var prop = errorToProperty(err);
                  var path = err.dataPath ? err.dataPath.substr(1) : null;

                  var fullPath = path && prop ? path + '.' + prop : path || prop;

                  return _extends({}, err, {
                    path: fullPath
                  });
                }));

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, _this2);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }();

    _this.state = _extends({}, _this.getStateFromProps(props));
    return _this;
  }

  Validator.prototype.componentWillReceiveProps = function componentWillReceiveProps(props) {
    this.setState(this.getStateFromProps(props));
  };

  Validator.prototype.getStateFromProps = function getStateFromProps(props) {
    var schema = props.schema;

    if (!schema) {
      return {
        validator: null
      };
    }

    var currentValidator = this.state && this.state.validator;
    if (!currentValidator || currentValidator.schema !== schema) {
      var ajv = this.ajv = this.ajv || (0, _ajv2.default)({
        allErrors: true
      });

      var validator = ajv.compile(schema);

      validator.schema = schema;

      return {
        validator: validator
      };
    }

    return {};
  };

  Validator.prototype.render = function render() {
    var children = this.props.children;

    if (!children) {
      return children;
    }

    return (0, _react.cloneElement)(children, {
      validate: this.validate
    });
  };

  return Validator;
}(_react.Component), _class.propTypes = {
  schema: _react.PropTypes.object,
  children: _react.PropTypes.node
}, _temp);
exports.default = Validator;